package timezonePatch;

import java.util.TimeZone;
import timezonePatch.model.*;
import timezonePatch.factory.*;

public abstract class TimeZonePatch extends TimeZone {
  private static TimezonePatchList timezonePatchList = null;
  public static TimeZone getTimeZone(String timeZone) {
    try{
      if (timezonePatchList == null) {
        timezonePatchList = TimeZonePatchListFactory.getTimezonePatchList();
      }
      if (timezonePatchList.exist(timeZone)) {
        return (TimeZone) timezonePatchList.getTimezonePatch(timeZone);
      }
      // in  case timezone id is not in timezonePatchList,
      // the java.util.TimeZone is returned
      return TimeZone.getTimeZone(timeZone);
    }catch (TimeZonePatchListFactoryException e){
      e.printStackTrace();
      // in case TimeZonePatchList could not be sucessfully built,
      // the java.util.TimeZone is returned
      return TimeZone.getTimeZone(timeZone);
    }
  }
}
