package timezonePatch.factory;

import timezonePatch.model.TimezonePatchList;
import com.wutka.jox.*;
// jox required libs: jox1.1.6, xerces 1.4.4 and dtdparser 1.2.1
import java.io.FileInputStream;
import java.io.File;

public class TimeZonePatchListFactory{
      private final static String XML_FILE = "timezonePatch.xml";

      public static TimezonePatchList getTimezonePatchList()
                throws TimeZonePatchListFactoryException{

        FileInputStream xmlFileimputStream = null;;

        JOXBeanInputStream joxIn = null;;
        try{
          xmlFileimputStream = new FileInputStream(XML_FILE);
          joxIn = new JOXBeanInputStream(xmlFileimputStream);
          return (TimezonePatchList) joxIn.readObject(
                             TimezonePatchList.class);
        }catch (Exception e){
          File file = new File(XML_FILE);
          throw new TimeZonePatchListFactoryException(
               "not able to read xml file. " + file.getAbsolutePath()
               + ". " + e.getMessage());
        } finally{
            try            {
                xmlFileimputStream.close();
                joxIn.close();
            } catch (Exception e) {}
        }
      }
}
