package timezonePatch.model;

import java.util.Hashtable;

import java.util.SimpleTimeZone;

public class TimezonePatchList
{
   private Hashtable simpleTimeZones = new Hashtable();
   private int year;

   public TimezonePatchList(){};

   public TimezonePatchList(int _year, Hashtable _simpleTimeZoneHashtable) {
     year = _year;
     simpleTimeZones = _simpleTimeZoneHashtable;
   }

   public SimpleTimeZone getTimezonePatch(String timezone)
   {
     return (SimpleTimeZone) simpleTimeZones.get(timezone);
   }

   public void setTimezonePatch(TimezonePatch[] timezonePatchArray) throws InvalidTimeZonePatchtException
   {
     for (int i=0; i < timezonePatchArray.length; i++)
     {
       simpleTimeZones.put(
          // timezone id
          timezonePatchArray[i].getId(),
          // SimpleTimeZone patch
          timezonePatchArray[i].toSimpleTimeZone());
     }
   }

   public int getYear()
   {
       return year;
   }

   public void setYear(int i)
   {
       year = i;
   }

    public void add(TimezonePatch patch) throws InvalidTimeZonePatchtException
    {
      simpleTimeZones.put(
         // timezone id
         patch.getId(),
         // SimpleTimeZone patch
         patch.toSimpleTimeZone());
    }

    public boolean exist(String id)
    {
      return simpleTimeZones.containsKey(id);
    }

    public boolean valid() throws InvalidTimeZonePatchtException
    {
        if ( (year < 1970) || (year > 3000))
          throw new InvalidTimeZonePatchtException("invalid year: " + year);
        return true;
    }

    public String toString()
    {
      StringBuffer strBuff = new StringBuffer();
      strBuff.append("Timezone Patch List ");
      strBuff.append(year);
      strBuff.append(" : \n");
      String id;
      SimpleTimeZone stz;
      java.util.Enumeration it = simpleTimeZones.keys();
      while (it.hasMoreElements())
      {
        id = (String)it.nextElement();
        stz = (SimpleTimeZone)simpleTimeZones.get(id);
        strBuff.append(id);
        strBuff.append("\n");
        strBuff.append(stz);
      }
      return strBuff.toString();
    }



}
